// Written by Aleksandar Maćašev as a part of the Chromapost project. www.chromapost.com
// Do not copy the code without permission. Contact me at macasev@gmail.com. I'm more than willing to grant permission.


import arb.soundcipher.*;

SoundCipher sc = new SoundCipher(this);


float r, g, b, pitch1, pitch2, pitch3, pitch1a, pitch2a, pitch3a, rgb;

float low=21; //lowest pitch
float high=108; //highest pitch

float brig; //brightness for date display



// total amount of colors
int numcol=2600;
Table table;
int n=-1;
color[] c = new int[numcol];
String[] days = new String[numcol];
String[] months = new String[numcol];
String[] monthsu = new String[numcol];
String[] years = new String[numcol];

String done; // date of the color
String donel, doner; // left and right dates
String done1, done2; // border dates big

PFont font;
PFont font2;
color cm; //get color for music
color cp; //get previous color for music
int col; //floored mouse value
PImage numbers; 
PImage start;
PImage footer;

int change=100; // number of colors in a segment
int s; // shift multiplier
int shift; //actual shift



color[] c1 = new int[change]; // sub array


//size
float h1=300; //height of the top field
float h2=300; //keyboard height
float k=10; //key width

int seg=26; // number of segments





//interface
float mar=45;
float cell=35;
//interface numbers
float x1;
int num;
String numm;
//interface shift
float ins=80;


void setup(){
  background(255);
  
  numbers = loadImage("numbers1.png");
  start= loadImage("headerCPsound.png");
  footer= loadImage("footer.png");
  //font = loadFont("HelveticaNeue-Light-24.vlw");
  font = loadFont("GothamRounded-Light-24.vlw");

  font2 = loadFont("GothamRounded-Book-12.vlw");

  
  //sc.instrument(62);

  
  size(1000, 850);
  //frameRate(5);
  background(255);
  
  table = loadTable("2600days.csv", "header");
  
  for (TableRow row : table.rows()) {
  String col = row.getString("color");
  String colo = "ff" + col ;
  n++;
  c[n] = unhex(colo);
  
  days[n]= row.getString("day");
  months[n]= row.getString("month");
  monthsu[n]=months[n].toUpperCase();
  years[n]= row.getString("year");

  
  
}


 
  noStroke();
  
  //image(img, 0, 0);
  
    //change shift steps
  s=0;
  
  
  
//initial date range  
  
  fill(0);
textFont(font);
textSize(24);
textAlign(CENTER);
done2=days[0]+" "+monthsu[0]+" "+years[0]+" "+"-"+" "+days[99]+" "+monthsu[99]+" "+years[99];
text(done2, width/2, h1/2);  


//image(start, 0, 0);


  

  
}


void draw(){
  



  shift=s*change; 
 
  
  //interface
  image(numbers, mar, h1+h2+ins);
noFill();
stroke(0);

for(int x=0; x<26; x++){
rect((x*cell)+mar, h1+h2+ins, cell, cell);

}

//interface use



for(int x=0; x<seg; x++){
  
if(mousePressed==true && (mouseY>h1+h2+ins && mouseY<h1+h2+ins+cell) && (mouseX>mar+(x*cell) && mouseX<mar+cell+(x*cell))){
s=x;

noStroke();
fill(255);
rect(0, 0, width, h1);


fill(0);
textFont(font);
textSize(24);
textAlign(CENTER);
done1=days[0+shift]+" "+monthsu[0+shift]+" "+years[0+shift]+" "+"-"+" "+days[99+shift]+" "+monthsu[99+shift]+" "+years[99+shift];
text(done1, width/2, h1/2);


}
}

noFill();
stroke(0);
rect(mar+(s*cell)+5, h1+h2+ins+5, 25, 25);


//if(s==0){
  
//fill(0);
//textFont(font);
//textSize(24);
//textAlign(CENTER);
//done2=days[0]+" "+monthsu[0]+" "+years[0]+" "+"-"+" "+days[99]+" "+monthsu[99]+" "+years[99];
//text(done2, width/2, h1/2);  
  
//}



//for(int x=0; x<seg; x++){
//x1=mar+(x*cell);  
 
//smooth(); 
//noStroke();
//fill(160);
//textFont(font);
//textSize(12);
//textAlign(CENTER);
//numm=str(x+1);
// text(numm, x1+(cell/2), height-mar-cell+(cell/2)+5); 
  
//}


//cursors
if((mouseY>h1+h2+ins && mouseY<h1+h2+ins+cell) && (mouseX>mar && mouseX<width-mar)){
cursor(HAND);
}
else if(mouseY>h1 && mouseY<h1+h2){
    cursor(CROSS);
}
else
{
  cursor(ARROW);
}

  
  
  
  
//fill the upper section with color and date
  if(mousePressed==true && (mouseY>h1 && mouseY<h1+h2)){
col=floor((mouseX)/k);

fill(c[col+shift]);
noStroke();
rect(0, 0, width, h1);

brig=brightness(c[col+shift]);

if(brig>127){
fill(0, 75);
}
else
{
  fill(255, 75);
}
 
textFont(font);
textSize(24);
textAlign(CENTER);
done=days[col+shift]+" "+monthsu[col+shift]+" "+years[col+shift];
text(done, width/2, h1/2);







  }
  
//left and right dates

noStroke();

fill(255);
rect(0, h1+h2, width, 30);









fill(0);

textFont(font2);
textSize(12);
textAlign(LEFT);
donel=days[0+shift]+" "+monthsu[0+shift]+" "+years[0+shift];
text(donel, k/2, h1+h2+k+k);
 

textAlign(RIGHT);
doner=days[99+shift]+" "+monthsu[99+shift]+" "+years[99+shift];
text(doner, width-(k/2), h1+h2+k+k);





  
//keyboard  
  
for(int x=0; x<change; x++){
  noStroke();
 fill(c[x+shift]);
 rect(x*k, h1, k, h2);

}

//play tone based on get color
if(mousePressed==true && (mouseY>h1 && mouseY<h1+(h2/3))){
 cm=get(mouseX, mouseY);
 cp=get(pmouseX, pmouseY);
 
r=red(cm);
g=green(cm);
b=blue(cm);

rgb=((r * 0.2126) + (g* 0.7152) + (b * 0.0722));
pitch1=map(rgb, 0, 255, low, high);
pitch1a=float(round(pitch1));

float []pitches = {pitch1a, pitch2a, pitch3a};

if(cm!=cp){

sc.playNote(pitch1a, 200, 10);

}

  }
  
  
 //play chord based on get color 
  
  if(mousePressed==true && (mouseY>h1+(h2/3) && mouseY<h1+((h2*2)/3))){
    

  
 cm=get(mouseX, mouseY);
 cp=get(pmouseX, pmouseY);
 
r=red(cm);
g=green(cm);
b=blue(cm);

pitch1=map(r, 0, 255, low, high);
pitch2=map(g, 0, 255, low, high);
pitch3=map(b, 0, 255, low, high);

pitch1a=float(round(pitch1));
pitch2a=float(round(pitch2));
pitch3a=float(round(pitch3));




float []pitches = {pitch1a, pitch2a, pitch3a};

if(cm!=cp){

sc.playChord(pitches, 200, 10.0);

}

  }
  
  
 //play broken chord based on color
 
 if(mousePressed==true && (mouseY>h1+((h2*2)/3) && mouseY<h1+h2)){
    

  
 cm=get(mouseX, mouseY);
 cp=get(pmouseX, pmouseY);
 
r=red(cm);
g=green(cm);
b=blue(cm);

pitch1=map(r, 0, 255, low, high);
pitch2=map(g, 0, 255, low, high);
pitch3=map(b, 0, 255, low, high);

pitch1a=float(round(pitch1));
pitch2a=float(round(pitch2));
pitch3a=float(round(pitch3));




float [] pitches = {pitch1a, pitch2a, pitch3a};
float [] dynamics = {200, 200, 200};
float [] durations = {0.2, 0.2, 0.2};

if(cm!=cp){




//sc.playChord(pitches, 200, 10.0);
sc.playPhrase(pitches, dynamics, durations);

}

  }
  
  
  
  
  
  
//dividing white lines  
stroke(255);
line(0, h1+(h2/3), width, h1+(h2/3));
line(0, h1+((h2*2)/3), width, h1+((h2*2)/3));
  
 
 
 image(footer, 0, h1+h2+200);
 

 
 

}




void mousePressed(){
 //play tone based on get color 
  if(mouseY>h1 && mouseY<h1+(h2/3)){
 cm=get(mouseX, mouseY); 
r=red(cm);
g=green(cm);
b=blue(cm);

rgb=((r * 0.2126) + (g* 0.7152) + (b * 0.0722));

pitch1=map(rgb, 0, 255, low, high);

pitch1a=float(round(pitch1));

sc.playNote(pitch1a, 200, 10);

  }
  
  //play chord based on get color
  if(mouseY>h1+(h2/3) && mouseY<h1+((h2*2)/3)){
    

  
 cm=get(mouseX, mouseY);
 
r=red(cm);
g=green(cm);
b=blue(cm);

pitch1=map(r, 0, 255, low, high);
pitch2=map(g, 0, 255, low, high);
pitch3=map(b, 0, 255, low, high);

pitch1a=float(round(pitch1));
pitch2a=float(round(pitch2));
pitch3a=float(round(pitch3));




float []pitches = {pitch1a, pitch2a, pitch3a};


sc.playChord(pitches, 200, 10.0);

  }
  
  
  
  //play broken chord based on get color
  
  if(mouseY>h1+((h2*2)/3) && mouseY<h1+h2){
    

  
 cm=get(mouseX, mouseY);
 
r=red(cm);
g=green(cm);
b=blue(cm);

pitch1=map(r, 0, 255, low, high);
pitch2=map(g, 0, 255, low, high);
pitch3=map(b, 0, 255, low, high);

pitch1a=float(round(pitch1));
pitch2a=float(round(pitch2));
pitch3a=float(round(pitch3));




float [] pitches = {pitch1a, pitch2a, pitch3a};
float [] dynamics = {200, 200, 200};
float [] durations = {0.2, 0.2, 0.2};


//sc.playChord(pitches, 200, 10.0);
sc.playPhrase(pitches, dynamics, durations);
  }
  
  

}